package com.muyu.cloud.etl.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.cloud.etl.mapper.SourceMapper;
import com.muyu.cloud.etl.service.SourceService;
import com.muyu.domain.Source;
import com.muyu.domain.req.SourceReq;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.sql.*;
import java.util.List;

@Service
public class SourceServiceImpl extends ServiceImpl<SourceMapper, Source> implements SourceService {
    @Autowired
    private SourceMapper sourceMapper;

    @Override
    public List<Source> selectSourceList(SourceReq sourceReq) {
       return sourceMapper.selectSourceList(sourceReq);
    }

    @Override
    public Source getInfo(Long id) {
        LambdaQueryWrapper<Source> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        lambdaQueryWrapper.eq(Source::getId, id);
        return this.sourceMapper.selectOne(lambdaQueryWrapper);
    }

    //新增
    @Override
    public int insertBasicConfigInfo(Source sourceReq) {
        int insert = sourceMapper.insert(sourceReq);
        return insert;
    }

    @Override
    public Integer deleteByIds(String ids) {
        LambdaQueryWrapper<Source> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        lambdaQueryWrapper.in(Source::getId, ids);
        int delete = sourceMapper.delete(lambdaQueryWrapper);
        return delete;
    }

    @Override
    public int updataSource(Source sourceReq) {
      Integer i=  sourceMapper.updataSource(sourceReq);
        return i;
    }

    @Override
    public int connectionTest(Source source) {
        String host = source.getHost();
        String port = source.getPort();
        String databaseName = source.getDatabaseName();
        String databaseType = source.getDatabaseType();
        String url = "jdbc:" + databaseType + "://" + host + ":" + port + "/" + databaseName + "?" + source.getConnectionParams();
        String user = source.getUsername();
        String password = source.getPassword();
        Connection conn = null;
        try {
            conn = DriverManager.getConnection(url, user, password);
            System.out.println("Connected to the MySQL server successfully.");

//            DatabaseMetaData metaData = conn.getMetaData();
//
//            ResultSet rs = metaData.getTables(databaseName,
//                    null, "%", new String[]{"TABLE", "VIEW"});
//
//            while (rs.next()) {
//                String tableName = rs.getString("TABLE_NAME"); // 或者 rs.getString(3)，但使用列名更清晰
//                System.out.println("Table Name: " + tableName);
//            }
//            rs.close();  // 记得关闭ResultSet
//
//            System.out.println(conn);


//            TableInfo tableInfoInsert = TableInfo.builder()
//                    .basicId(source.getId())
//                    .parentId(0L)
//                    .tableRemark("")
//                    .center("Y")
//                    .type("dataSource")
//                    .tableName(source.getDataSourcesSystemName() + "(" + databaseName + ")")
//                    .createBy(SecurityUtils.getUsername())
//                    .createTime(new Date())
//                    .build();
        } catch (SQLException e) {
            return 0;
        }



        return  1;
    }

}
